/*  '**********************************************************************
    '*  Program  : EXTRIG.C                                               *
    '*  Date     : 01/11/96                         Advantech Co., Ltd.   *
    '*====================================================================*
    '*                                                                    *
    '*  This demo program performs one external triggered A/D conversion  *
    '*  and program control data transfer without the MIC-2718 driver.    *
    '*                                                                    *
    '**********************************************************************
*/
#include <stdio.h>
#include <dos.h>
#include <bios.h>
#include <conio.h>

char *gain_str[12]={"+/-5V","+/-0.5V","+/-0.05V","+/-0.005V","0-10V","0-1V",
                   "0-0.1V","0-0.01V","+/-10V","+/-1V","+/-0.1V","+/-0.01V"};
main()
{
 int status  ,s_end  ,start ,stop ,count;
 int dtl ,dth ,adl   ,adt ,c_reg ,s_ch_val ,r_ch;
 int chv ,ch_gain[16];
 int port,val, i, j;
 port=0x300;              /* SET I/O PORT BASE ADDRESS */
 clrscr();
/********** STEP 1: INITIALIZE & SELECT SOFTWARE TRIGGER *************/
 val=0x70;
 outportb(port+9,val);
 c_reg = inportb(port+9);
 textbackground(BLUE);
 textcolor(WHITE);
 cprintf("Base Address = %X ",port);
 textbackground(BLACK);
 textcolor(LIGHTGRAY);
 cprintf("\r\n");
 if (c_reg != val)
     {
       textbackground(RED);
       textcolor(BLINK+WHITE);
       cprintf("MIC-2718 hardware verification failed!\a\r\n");
       textbackground(BLACK);
       textcolor(LIGHTGRAY);
       exit(0);
     }
 outportb(port+8,1);                 /* CLEAR INTERRUPT REQUEST  */

   clrscr();
   textbackground(BLUE);
   textcolor(WHITE);
   cprintf("%c",0xc9);
     for(count=1;count<42;count++)
   cprintf("%c",0xcd);
   cprintf("%c\r\n",0xbb);
   cprintf("%c                                         %c\r\n",0xba,0xba);
   cprintf("%c  1. set JP2 to \" ENB \" .                %c\r\n",0xba,0xba);
   cprintf("%c                                         %c\r\n",0xba,0xba);
   cprintf("%c  2. TRIG of CN1 connects to a pulse     %c\r\n",0xba,0xba);
   cprintf("%c     generator .                         %c\r\n",0xba,0xba);
   cprintf("%c                                         %c\r\n",0xba,0xba);
   cprintf("%c",0xba);
   textbackground(BLUE);
   textcolor(BLINK+LIGHTGRAY);
   cprintf("      Press any key to continue ....     ");
   textbackground(BLUE);
   textcolor(WHITE);
   cprintf("%c\r\n%c",0xba,0xc8);
     for(count=1;count<42;count++)
       cprintf("%c",0xcd);
   cprintf("%c\r\n",0xbc);
   textbackground(BLACK);
   textcolor(LIGHTGRAY);
   getch();
   clrscr();

/*  ******** STEP 2: READ A/D STATUS REGISTER **************************** */

 status = inportb(port+8);
 if ((status & 0x20)==0x20)
     s_end = 1;             /* SINGLE-ENDED MODE */
 else
     s_end = 0;             /* DIFFERENTIAL MODE */

redo:
 if(s_end==1)
    {
      printf("\nenter start channel number <0-15> ");
      scanf("%d",&start);
      printf("enter stop channel number <0-15> ");
      scanf("%d",&stop);
    }
 else
    {
       printf("\nenter start channel number <0-7> ");
       scanf("%d",&start);
       printf("enter stop channel number <0-7> ");
       scanf("%d",&stop);
     }

 if ((s_end==0) & (stop>7))
     {
       textbackground(RED);
       textcolor(BLINK+WHITE);
       cprintf("Entered channel failed! re-do!\a\r\n");
       textbackground(BLACK);
       textcolor(LIGHTGRAY);
       goto redo;
     }

 if ((s_end==1) & (stop>15))
     {
       textbackground(RED);
       textcolor(BLINK+WHITE);
       cprintf("Entered channel failed! re-do!\a\r\n");
       textbackground(BLACK);
       textcolor(LIGHTGRAY);
       goto redo;
     }

 if (start > stop)
     {
       textbackground(RED);
       textcolor(BLINK+WHITE);
       cprintf("Entered channel failed!\a\r\n");
       textbackground(BLACK);
       textcolor(LIGHTGRAY);
       goto redo;
     }

/*********** STEP 3: SET A/D RANGE CODE *****************/

 printf("\n********************** A/D Range Code Table ********************\n");
 for(j=0; j<4; j++)
    {
    printf("*       ");
    for(i=0; i<3; i++)
       printf("%2d) %-12s",i+3*j,gain_str[i+3*j]);
    printf("       *\n");
    }
 for(i=0;i<8;i++)
    printf("********");
 puts("");

 for(i=start; i<=stop; i++)
    {
    printf("ENTER RANGE CODE <0 -- 11> OF CHANNEL %d :",i);
    scanf("%d",&ch_gain[i]);
    outportb(port+2, i);
    outportb(port+1, ch_gain[i]);
    printf("\n");
    }

/********* STEP 4: SET SCAN CHANNEL RANGE  ***********************/

 s_ch_val=stop*16+start;      /* SET SCAN CHANNEL VALUE */
 outportb(port+2,s_ch_val);
 r_ch = inportb(port+2);      /* READ BACK CHANNEL VALUE */
   if (r_ch != s_ch_val)
     {
       textbackground(RED);
       textcolor(BLINK+WHITE);
       printf("Scan channel  setting failed!\a\r\n");
       textbackground(BLACK);
       textcolor(LIGHTGRAY);
       exit(0);
     }

/********* STEP 5: PERFORM SINGLE A/D CONVERSION  ***********/
    outportb(port+9,02);
 do {
reread:
    status = inport(port+8);
    if ((status & 0x10)!=0x10)    /* CHECK INT FLAG */
       goto reread;
    dtl = inportb(port);
    dth = inportb(port+1);
    adl = dtl/16;
    adt = dth*16+adl;
    chv = dtl-adl*16;
    cprintf(" CURRENT CHANNEL = %2d   A/D RANGE=%-7s     "
	   ,chv, gain_str[ch_gain[chv]]);
    cprintf("A/D DATA=%d\r\n",adt);
    cprintf(" NEXT SCAN CHANNEL= %d\r\n",(status & 0x0f));
    cprintf("START SCAN CHANNEL= %d\r\n",start);
    cprintf(" STOP SCAN CHANNEL= %d\r\n\n",stop);

    textbackground(CYAN);
    textcolor(BLUE);
    cprintf("Press any key to stop !!");
    textbackground(BLACK);
    textcolor(LIGHTGRAY);
    cprintf("\r\n\n");
    outportb(port+8,0);  /* clear interrupt */
    }  while(bioskey(1) == 0 );
    clrscr();
    textbackground(BLUE);
    textcolor(YELLOW);
    cprintf("%c",0xc9);
      for(count=1;count<44;count++)
	 cprintf("%c",0xcd);
    cprintf("%c\r\n",0xbb);
    cprintf("%c                                           %c\r\n",0xba,0xba);
    cprintf("%c           Thank you for using             %c\r\n",0xba,0xba);
    cprintf("%c                                           %c\r\n",0xba,0xba);
    cprintf("%c      external trigger demo program !!     %c\r\n",0xba,0xba);
    cprintf("%c                                           %c\r\n",0xba,0xba);
    cprintf("%c                                           %c\r\n",0xba,0xba);
    cprintf("%c                       ADVANTECH CO.,LTD.  %c\r\n",0xba,0xba);
    cprintf("%c",0xc8);
      for (count=1;count<44;count++)
	 cprintf("%c",0xcd);
    cprintf("%c\r\n",0xbc);
    textbackground(BLACK);
    textcolor(LIGHTGRAY);
   }

