
/*  '**********************************************************************
    '*  Program  : DEMO01.C                                               *
    '*  Revision : C1                                                     *
    '*  Date     : 01/11/1996                       Advantech Co., Ltd.   *
    '*====================================================================*
    '*                                                                    *
    '*  This demo program performs software triggered one A/D conversion  *
    '*  and program control data transfer with external CJC block.        *
    '*                                                                    *
    '**********************************************************************
*/
#include <stdio.h>
#include <dos.h>
float Max[12]={ 5, 0.5, 0.05, 0.005, 0, 0,  0,   0, 10, 1, 0.1, 0.01};
float Min[12]={-5,-0.5,-0.05,-0.005,10, 1,0.1,0.01,-10,-1,-0.1,-0.01};

extern float tc_error_volts(),temp_scale(),tc_temp();

main()
{
 int status, CJCgain, CJCdata;
 int gain, data, units, type;
 unsigned CJCchan, chan;
 float CJCtemp, CJCvolt;
 float tmp, T1, Vs, Ve, Vc;
 float temp, volt;
 int dtl ,dth ,adl ,c_reg, chv;
 int port,val;
 port=0x300;              /* SET I/O PORT BASE ADDRESS */

 clrscr();
/********** STEP 1: INITIALIZE & SELECT SOFTWARE TRIGGER *************/
 val=0x70;
 outportb(port+9,val);               /* software trigger */
 c_reg = inportb(port+9);
 if (c_reg != val)
     {
     printf("MIC-2718 hardware verification failed!\n");
     exit(0);
     }
 outportb(port+8,1);                 /* CLEAR INTERRUPT REQUEST  */

/*  ******** STEP 2: READ A/D STATUS REGISTER **************************** */

 status = inportb(port+8);
 if ((status & 0x20)==0x20)
    {
     printf("Please set sw1 in different mode!\n");
     exit(0);
    }

redo1:
    printf("enter CJC channel number <0-7> ");
    scanf("%d",&CJCchan);
    printf("enter measure channel number <0-7> ");
    scanf("%d",&chan);

 if ((CJCchan > 7) || (chan > 7))
     {
     printf("Entered channel failed! re-do!\n");
     goto redo1;
     }

redo2:
    printf("enter CJC channel's gain code <0-11> ");
    scanf("%d",&CJCgain);
    printf("enter measure channel's gain code <0-11> ");
    scanf("%d",&gain);

 if ((CJCgain > 11) || (gain > 11))
     {
     printf("Entered gain code failed! re-do!\n");
     goto redo2;
     }

     clrscr();
/********* STEP 2: PERFORM SINGLE A/D CONVERSION FOR CJC ***********/
 do {
    CJCchan = (CJCchan<<4) + CJCchan;
    outportb(port+2, CJCchan);
    outportb(port+1, CJCgain);
    delay(10);
    outportb(port+9,0);
    outportb(port+8,0);
    outportb(port,0);
          do
          {
            status=inportb(port+8);
          }
          while ((status&0x80)==0x80);
    dtl = inportb(port);
    delay(1);
    dth = inportb(port+1);
    adl = dtl/16;
    CJCdata = dth*16+adl;
    chv = dtl-adl*16;
    CJCvolt =((Max[CJCgain] - Min[CJCgain]) * CJCdata / 4096) + Min[CJCgain];
    CJCtemp = (float)CJCvolt/(4.99*1000);
    CJCtemp = (float)CJCtemp*1000000 - 273.15;

	    /*
           data =( (5 - (-5)) * data / 4096) + (-5);
	       (5 - (-5)) : A/D input range (-5V  to  5V)
	       4096       : Full scale 12 bit A/D data
           data       : A/D input data
	       (-5)       : A/D input range "-5" V
	    */

    gotoxy(12,9);
    printf("\nCurrent CJC channel=%2d \n", chv);
    printf("A/D conversion CJC CJCdata=%4d \n", CJCdata);
    printf("A/D conversion CJC CJCvolt=%1.2f V\n", CJCvolt);
    printf("A/D conversion CJC CJCtemp=%3.2f C\n", CJCtemp);

/********* STEP 3: PERFORM SINGLE A/D CONVERSION FOR TEMPERATURE ********/
    chan= (chan<<4) + chan;
    outportb(port+2, chan);
    outportb(port+1, gain);
    delay(1000);
    outportb(port+8,0);
    outportb(port+9,0);
    outportb(port,0);
          do
          {
            status=inportb(port+8);
          }
          while ((status&0x80)==0x80);
    dtl = inportb(port);
    delay(1);
    dth = inportb(port+1);
    adl = dtl/16;
    data = dth*16+adl;
    chv = dtl-adl*16;
    volt =((Max[gain] - Min[gain]) * data / 4096) + Min[gain];

	    /*
           data =( (5 - (-5)) * data / 4096) + (-5);
	       (5 - (-5)) : A/D input range (-5V  to  5V)
	       4096       : Full scale 12 bit A/D data
           data       : A/D input data
	       (-5)       : A/D input range "-5" V
	    */

    // Units are degrees Celsius.
    type = 1;                // J type =0 , B type =4
                             // K      =1 , R      =5
                             // S      =2 , E      =6
                             // T      =3 , N      =7

    Ve = tc_error_volts(CJCtemp, type);  // Calculate error vlotage Ve.

    /* STEP 5: Calculate corrected voltage. */

    Vc = volt + Ve;

    /* Step 6: Calculate temperature using thermocouple tables. */

    tmp = tc_temp(Vc, type); // J type =0 , B type =4
                             // K      =1 , R      =5
                             // S      =2 , E      =6
                             // T      =3 , N      =7
    /* Now convert to the indicated temperature scale.*/

    units = 0;
	tmp = temp_scale(tmp, units);  // =0 Celsius
                                   // =1 Fahrenheit
                                   // =2 Kelvin
                                   // =3 Rankine

    printf("\nCurrent measure channel=%2d \n", chv);
    printf("A/D conversion measure data=%4d \n", data);
    printf("A/D conversion measure volt=%1.7f V\n", volt);
    printf("A/D conversion measure temp=%3.2f C\n", tmp);

    printf("\n\n\nEnter any key continue to exit.\n");
    } while(!(kbhit()));
}
