//#include "public.h"


  /* read one key from keyboard */
  int readkey()
  {
   while (bioskey(1)==0);
   return(bioskey(0));
  }



  void menucheck(int rdkey)
  {
  do{
		switch (menuI)
		{
			case IRQ_LEVEL:
				 if(irqI==NOONE){
					   if(rdkey==LTARR) menuI--;
					   else menuI++;
				 }
				 else  rdkey=OK;
				 break;
			case AD_RANGE:
				 if(ad_range_no==NOONE){
					   if(rdkey==LTARR) menuI--;
					   else menuI++;
				 }
				 else  rdkey=OK;
				 break;
			case DA_RANGE:
				 if(da_range_no==NOONE){
					   if(rdkey==LTARR) menuI--;
					   else menuI++;
				 }
				  else  rdkey=OK;
				 break;
			case EDIT:
				 if(da_no==NOONE&&do_no==NOONE){
						if(rdkey==LTARR) menuI--;
						else menuI++;
				 }
				 else  rdkey=OK;
				 break;
			default:
				 rdkey=OK;
	   }
  }while(rdkey!=OK);
  if (menuI<0) menuI=TOTALMENU-1;
  if (menuI>=TOTALMENU) menuI=0;

 }




  /* menu selection */
void  menuselect()
{
   int rdkey;
   int complete;
   int edtype;
   int admode;

   if (bioskey(1)==0) return;
   rdkey=bioskey(0);
   switch (rdkey) {
	 case LTARR:
				menuI--;
				menucheck(rdkey);
				showmenu(menuI);
				break;
	 case RTARR:
				menuI++;
				menucheck(rdkey);
				showmenu(menuI);
				break;
	 case ENTER:
				  switch (menuI)
				  {
					case CARDTYPE:
						 if(boardI==PCL732) dis_732();
						 complete=selectcard();
//						 drawscreen();
						 showmenu(menuI);
						 showhelp(-1);
						 break;
					case ADDRESS:
						 complete=selectaddr();
						 break;
					case IRQ_LEVEL:
						 complete=selectirq();
						 break;
					case AD_RANGE:
						 switch (boardI)
						 {
						   case PCL711B:
								complete=selectad();
								break;
						   case PCL813B:
								complete=selecttype(&edtype);

								switch (edtype)
								{
								  case 0:
									   complete=selectad();
									   break;
								  case 1:
									   complete=indiv();
									   break;
								  default:
									   break;
								}


								break;
						   case PCL818:
						   case PCL818H:
						   case PCL818HD:
						   case PCL1800:
                           case MIC2718:
						   case PCL818HG:
						   case PCL818L:
								complete=selecttype(&edtype);

								switch (edtype)
								{
								  case 0:
									   complete=selectad();
									   break;
								  case 1:
									   complete=indiv();
									   break;
								  default:
									   break;
								}
								break;
						   case PCL812PG:
								complete=selecttype(&edtype);
								switch (edtype)
								{
								  case 0:
									   complete=selectad();
									   break;
								  case 1:
									   complete=indiv();
									   break;
								  default:
									   break;
								}
								break;
						   default:
								complete=selectad();
								break;
						 }
						 break;
					case DA_RANGE:
						 complete=selectda();
						 break;
					case EDIT:
						 complete=selectedit();
						 break;
					case HELP:
						 complete=selectionhelp();
						 break;
					default:
						 break;
				  }
				break;
	 case F1:
				if (vc_f==ON) vc_f=OFF;
				else vc_f=ON;
				break;
	 case F2:   if (boardI==PCL813B)
				 {
				   if (ad_32==OFF) ad_32=ON;
				   else  ad_32=OFF;
				   drawscreen();
				   showhelp(-1);
				   showmenu(menuI);
				}
				break;
	 case F10:
				if (boardI==PCL860) hold860(OFF);
				if ((boardI==PCL730)||(boardI==PCL732)) {
				   disable();
				   setvect(old_irqI+8,old_handler);
				   enable();
				}
				cursoron();
				setback(BLACK);
				clrscr();
				exit(0);
	 default   :
				break;
   }
  }

  /* test card selection */
int selectcard()
{
   int rdkey;
   int defcard;
   int defmenu;
   showhelp(CARDTYPE);
   winproc(menuI,SETUP);
   defmenu=menuI;
   defcard=boardI;
   ad_32=OFF;
   do {
	 showitem(menuI,defcard);
	 switch (rdkey=readkey()) {
	   case DNARR:
				  if (++defcard>=TOTALCARD) defcard=0;
				  break;
	   case UPARR:
				  if (--defcard<0) defcard=TOTALCARD-1;
				  break;
	   case ENTER:
				  boardI=defcard;

				  break;
	   case LTARR:
				  if (--defmenu<0) defmenu=TOTALMENU-1;
				  break;
       case RTARR:
                  if (++defmenu>=TOTALMENU) defmenu=0;
                  break;
       default   :
				  break;
	 }
   }
   while ((rdkey!=ENTER)&&(rdkey!=ESC)&&(rdkey!=LTARR)&&(rdkey!=RTARR));
   menucheck(rdkey);
   winproc(menuI,RECOVER);
   drawscreen();
   if (rdkey==ENTER) {
//	 clearfield();

	 board_default();
	 init_AD();
	 init_DA();
	 init_DO();
	 init_DI();
	 read_AD();
	 read_DI();
	 show_AD();
	 show_DI();
	 show_DO(KNULL);
	 show_DA(KNULL);
	 defmenu=ADDRESS;
   }
   menuI=defmenu;
   menucheck(rdkey);
   showmenu(menuI);
   showhelp(KNULL);
   if ((rdkey==ENTER)||(rdkey==ESC)) {return(OK);}
   else return(FAIL);
}

  /* address selection */
int selectaddr()
{
   int rdkey;
   int defbase;
   int defmenu;
   showhelp(ADDRESS);
   winproc(menuI,SETUP);
   defmenu=menuI;
   defbase=baseI;
   do {
	 showitem(menuI,defbase);
	 switch (rdkey=readkey()) {
	   case DNARR:
				  defbase+=0x10;
				  if (defbase>=0x400) defbase=0x200;
				  break;
	   case UPARR:
				  defbase-=0x10;
				  if (defbase<0x200) defbase=0x3f0;
				  break;
	   case ENTER:
				  baseI=defbase;
				  break;
	   case LTARR:
				  if (--defmenu<0) defmenu=TOTALMENU-1;
				  break;
	   case RTARR:
				  if (++defmenu>=TOTALMENU) defmenu=0;
				  break;
	   default   :
				  break;
	 }
   }
   while ((rdkey!=ENTER)&&(rdkey!=ESC)&&(rdkey!=LTARR)&&(rdkey!=RTARR));
   menucheck(rdkey);
   winproc(menuI,RECOVER);
   if (rdkey==ENTER) {
	 clearfield();
	 init_AD();
	 init_DA();
	 init_DO();
	 init_DI();
	 read_AD();
	 read_DI();
	 show_AD();
	 show_DI();
	 show_DO(KNULL);
	 show_DA(KNULL);
	 defmenu=IRQ_LEVEL;
   }
   menuI=defmenu;
   menucheck(rdkey);
   showmenu(menuI);
   showhelp(KNULL);
   if ((rdkey==ENTER)||(rdkey==ESC)) {return(OK);}
   else return(FAIL);
  }

  /* IRQ level selection */
int selectirq()
{
   int rdkey;
   int defirq;
   int defmenu;

   if (irqI != 0) {
	  showhelp(IRQ_LEVEL);
      winproc(menuI,SETUP);
      }
   defmenu=menuI;
   defirq=irqI;
   do {
	 showitem(menuI,defirq);
     switch (rdkey=readkey()) {
	   case DNARR:
				  defirq+=0x01;
				  if (defirq>=0x8) defirq=0x02;
				  break;
	   case UPARR:
				  defirq-=0x01;
				  if (defirq<0x02) defirq=0x07;
				  break;
	   case ENTER:
				  irqI=defirq;
				  break;
	   case LTARR:
				  if (--defmenu<0) defmenu=TOTALMENU-1;
				  break;
	   case RTARR:
				  if (++defmenu>=TOTALMENU) defmenu=0;
				  break;
	   default   :
				  break;
	 }
   }
   while ((rdkey!=ENTER)&&(rdkey!=ESC)&&(rdkey!=LTARR)&&(rdkey!=RTARR));
   if (irqI != 0) winproc(menuI,RECOVER);

   if (rdkey==ENTER) {
	 clearfield();
	 init_AD();
	 init_DA();
	 init_DO();
	 init_DI();
	 read_AD();
	 read_DI();
	 show_AD();
	 show_DI();
	 show_DO(KNULL);
	 show_DA(KNULL);
	 defmenu=AD_RANGE;
   }
   menuI=defmenu;
   menucheck(rdkey);
   showmenu(menuI);
   showhelp(KNULL);
   if ((rdkey==ENTER)||(rdkey==ESC)) {return(OK);}
   else return(FAIL);
  }

  /* A/D range selection */
int selectad()
{
   int rdkey;
   int defad;
   int defmenu;
   int indx;

   if (ad_range_no>0) showhelp(AD_RANGE);
   winproc(menuI,SETUP);
   defmenu=menuI;
   defad=ad_range;
   do {
	 showitem(menuI,defad);
	 switch (rdkey=readkey()) {
	   case DNARR:
				  if (++defad>=ad_range_no) defad=0;
				  break;
	   case UPARR:
				  if (--defad<0) defad=ad_range_no-1;
				  break;
	   case ENTER:
				  ad_range=defad;
				  if (boardI==PCL818HG||boardI==MIC2718)
				  {  switch(ad_range)
					 {
					   case 2:
					   case 3:
					   case 6:
					   case 7:
                       case 10:
                       case 11:
                                for (indx=0;indx<ad_no;indx++) mvc_f[indx]=ON;
                                break;
                      default:
								for (indx=0;indx<ad_no;indx++) mvc_f[indx]=OFF;
                                break;
					  }
                  }

				  for (indx=0;indx<ad_no;indx++) ad_gain[indx]=ad_range;
				  break;
	   case LTARR:
				  if (--defmenu<0) defmenu=TOTALMENU-1;
				  break;
	   case RTARR:
				  if (++defmenu>=TOTALMENU) defmenu=0;
				  break;
	   default   :
				  break;
	 }
   }
   while ((rdkey!=ENTER)&&(rdkey!=ESC)&&(rdkey!=LTARR)&&(rdkey!=RTARR));
   winproc(menuI,RECOVER);
   if (rdkey==ENTER)
   {
	  if (ad_range_no>0) {
		init_AD();
		read_AD();
		show_AD();
	  }
	  defmenu=DA_RANGE;
   }
   menuI=defmenu;
   menucheck(rdkey);
   showmenu(menuI);
   showhelp(KNULL);
   if ((rdkey==ENTER)||(rdkey==ESC)) {return(OK);}
   else return(FAIL);
  }
  
  /* D/A range selection */
int selectda()
{
   int rdkey;
   int defda;
   int defmenu;
   int ch;

   if (da_range_no>0) showhelp(DA_RANGE);
   winproc(menuI,SETUP);
   defmenu=menuI;
   defda=da_range;
   do {
     showitem(menuI,defda);
     switch (rdkey=readkey()) {
       case DNARR:
				  if (++defda>=da_range_no) defda=0;
                  break;
	   case UPARR:
				  if (--defda<0) defda=da_range_no-1;
				  break;
	   case ENTER:
				  da_range=defda;
				  break;
	   case LTARR:
				  if (--defmenu<0) defmenu=TOTALMENU-1;
				  break;
	   case RTARR:
				  if (++defmenu>=TOTALMENU) defmenu=0;
				  break;
	   default   :
				  break;
	 }
   }
   while ((rdkey!=ENTER)&&(rdkey!=ESC)&&(rdkey!=LTARR)&&(rdkey!=RTARR));
   winproc(menuI,RECOVER);
   if (rdkey==ENTER) {
	 if (da_range_no>0) {
	   init_DA();
	   for (ch=0;ch<da_no;ch++) write_DA(ch);
	   show_DA(KNULL);
	 }
	 defmenu=EDIT;
   }
   menuI=defmenu;
   menucheck(rdkey);
   showmenu(menuI);
   showhelp(KNULL);
   if ((rdkey==ENTER)||(rdkey==ESC)) return(OK);
   else return(FAIL);
  }

  /* editing item selection */
int selectedit()
{
   int rdkey;
   int deffun;
   int defmenu;

   deffun=0;
   showhelp(EDIT);
   winproc(menuI,SETUP);
   defmenu=menuI;
   if (da_no==0) deffun=1;
   else if (do_no==0) deffun=0;
   else deffun=editem;
   do {
	 showitem(menuI,deffun);
	 switch (rdkey=readkey()) {
	   case DNARR:
				  if (da_no>0) if (++deffun>=2) deffun=0; else;
				  else deffun=1;
				  if (do_no==0) deffun=0;
				  break;
	   case UPARR:
				  if (da_no>0) if (--deffun<0) deffun=1; else;
				  else deffun=1;
				  if (do_no==0) deffun=0;
				  break;
	   case ENTER:
				  editem=deffun;
				  edit_f=ON;
				  break;
	   case LTARR:
				  if (--defmenu<0) defmenu=TOTALMENU-1;
				  break;
	   case RTARR:
				  if (++defmenu>=TOTALMENU) defmenu=0;
				  break;
	   default   :
				  break;
	 }
   }
   while ((rdkey!=ENTER)&&(rdkey!=ESC)&&(rdkey!=LTARR)&&(rdkey!=RTARR));
   winproc(menuI,RECOVER);
   menuI=defmenu;
   switch (rdkey) {
	 case ENTER:
		  showmenu(KNULL);
		  switch (editem) {
			case 0:
				 if (da_no>0) {
					show_DA(dach);
					showhelp(DAEDIT);
				 }
				 else {
					edit_f=OFF;
					showmenu(EDIT);
				 }
				 break;
			case 1:
				 if (do_no>0) {
					show_DO(doch);
					showhelp(DOEDIT);
				 }
				 else {
					edit_f=OFF;
					showmenu(EDIT);
				 }
				 break;
			default:
				 break;
		  }
		  return(OK);
	 case ESC:

		  showmenu(menuI);
		  return(OK);
	 default:
		  menuI=defmenu;
		  menucheck(rdkey);
		  showmenu(menuI);
		  return(FAIL);
   }
}
  /* HELP Selection */
int selectionhelp()
{
   int rdkey;
   int defbase;
   int defmenu;
   showhelp(HELP);
   winproc(menuI,SETUP);
   showitem(HELP,0);
   defmenu=menuI;
   defbase=baseI;
   do{

	 switch (rdkey=readkey()) {

	   case LTARR:
				  if (--defmenu<0) defmenu=TOTALMENU-1;
				  break;
	   case RTARR:
				  if (++defmenu>=TOTALMENU) defmenu=0;
				  break;
	   case ENTER:
					break;
	   case ESC:
					break;
	   default   :
				  break;
	 }
   }
   while ((rdkey!=ENTER)&&(rdkey!=ESC)&&(rdkey!=LTARR)&&(rdkey!=RTARR));
	winproc(menuI,RECOVER);
	menuI=defmenu;
	 menucheck(rdkey);
	showmenu(menuI);
	showhelp(KNULL);
	if ((rdkey==ENTER)||(rdkey==ESC)) {return(OK);}
	else return(FAIL);
}

  /* A/D setting type selection */
int selecttype(deftype)
int *deftype;
{
   int rdkey;
   showhelp(ADSET);
   winproc(ADSET,SETUP);
   *deftype=1;
   do {
	 showitem(ADSET,*deftype);
	 switch (rdkey=readkey()) {
	   case DNARR:
				  if (++*deftype>=2) *deftype=0;
				  break;
	   case UPARR:
				  if (--*deftype<0) *deftype=1;
				  break;
	   case ENTER:

				  break;
	   case LTARR:
				  menuI--;
				  menucheck(rdkey);
				  *deftype=KNULL;
				  break;
	   case RTARR:
				  menuI++;
				  menucheck(rdkey);
				  *deftype=KNULL;
				  break;
	   case ESC:
				  *deftype=KNULL;
				  break;
	   default   :
				  break;
	 }
   }
   while ((rdkey!=ENTER)&&(rdkey!=ESC)&&(rdkey!=LTARR)&&(rdkey!=RTARR));
   winproc(ADSET,RECOVER);
   if((rdkey==ENTER)&&(SorDMode==ON)){
			if(selectadmode(&ad_DorS)!=OK)
			 *deftype=KNULL;
			if(ad_DorS==SIGNLE) ad_no=16;
			else ad_no=8;
			clearfield();
   }
   showmenu(menuI);
   if ((rdkey==ENTER)||(rdkey==ESC)) return(OK);
   else return(FAIL);
  }
  /* A/D input mode selection */
  int selectadmode(deftype)
  int *deftype;
  {
   int rdkey;

   showhelp(ADDorS);
   winproc(ADDorS,SETUP);
   *deftype=1;
   do {
	 showitem(ADDorS,*deftype);
	 switch (rdkey=readkey()) {
	   case DNARR:
				  if (++*deftype>=2) *deftype=0;
				  break;
	   case UPARR:
				  if (--*deftype<0) *deftype=1;
				  break;
	   case ENTER:
				  break;
	   case LTARR:
				  menuI--;
				  menucheck(rdkey);
				  *deftype=KNULL;
				  break;
	   case RTARR:
				  menuI++;
				  menucheck(rdkey);
				  *deftype=KNULL;
				  break;
	   case ESC:
				  *deftype=KNULL;
				  break;
	   default   :
				  break;
	 }
   }
   while ((rdkey!=ENTER)&&(rdkey!=ESC)&&(rdkey!=LTARR)&&(rdkey!=RTARR));
   winproc(ADDorS,RECOVER);
   showmenu(menuI);
   if ((rdkey==ENTER)) return(OK);
   else return(FAIL);
  }

  /* programmable A/D range setting */
  int indiv()
  {
   int rdkey;
   int chno,indx;
   int defgain[32];
   int defmenu;
  
   showhelp(INDIVIDUAL);
   winproc(INDIVIDUAL,SETUP);
	 for (chno=0;chno<ad_no;chno++) defgain[chno]=ad_gain[chno];
	 defmenu=menuI;
	 chno=0;

   do {
	 showitem(INDIVIDUAL,chno);


	 switch (rdkey=readkey()) {

	   case DNARR:
				  if (++chno>=ad_no) chno=0;
				  break;
	   case UPARR:
				  if (--chno<0) chno=ad_no-1;
				  break;
	   case PGUP:
				  if (++ad_gain[chno]>=ad_range_no) ad_gain[chno]=0;
				  break;
	   case PGDN:
				  if (--ad_gain[chno]<0) ad_gain[chno]=ad_range_no-1;
				  break;
	   case LTARR:
				  if (--defmenu<0) defmenu=TOTALMENU-1;
				  break;
	   case RTARR:
				  if (++defmenu>=TOTALMENU) defmenu=0;
				  break;
	   case ENTER:
				  if (boardI==PCL818HG||boardI==MIC2718)
				  {
					 for (indx=0;indx<ad_no;indx++)
					 {
					  switch(ad_gain[indx])
					  {
						 case 2:
						 case 3:
						 case 6:
						 case 7:
						 case 10:
						 case 11:
								mvc_f[indx]=ON;
								break;
						 default:
								mvc_f[indx]=OFF;
								break;
						}
					   }
				   }

				  defmenu=menuI;
				  init_AD();
				  break;
	   case ESC:
				  for (chno=0;chno<ad_no;chno++) ad_gain[chno]=defgain[chno];
				  break;
	   default   :
				  break;
	 }
   }
   while ((rdkey!=ENTER)&&(rdkey!=ESC)&&(rdkey!=LTARR)&&(rdkey!=RTARR));
   winproc(INDIVIDUAL,RECOVER);
   menuI=defmenu;
   menucheck(rdkey);
   showmenu(menuI);
   showhelp(KNULL);
   if ((rdkey==ENTER)||(rdkey==ESC)) return(OK);
   else return(FAIL);
  }

  /* edit D/A output */
void  daservice()
  {
   int index;
   int rdkey;

	if (editem!=0) return;
	if (bioskey(1)==0) return;
	rdkey=bioskey(0);
	  switch (rdkey) {
		case UPARR:
				   if (--dach<0) dach=da_no-1;
				   break;
		case DNARR:
				   if (++dach>=da_no) dach=0;
				   break;
		case PGUP :
				   da_value[dach]+=0.01;
				   break;
		case PGDN :
				   da_value[dach]-=0.01;
				   break;
		case LTARR:
				   da_value[dach]+=0.1;
				   break;
		case RTARR:
				   da_value[dach]-=0.1;
				   break;
		case ESC  :
				   edit_f=OFF;
				   show_DA(KNULL);
				   showmenu(menuI);
				   showhelp(KNULL);
				   return;
		default :
				   break;
	  }
	  write_DA(dach);
	  show_DA(dach);
  }

  /* edit D/O status */
void  doservice()
  {
	int rdkey;

	if (editem!=1) return;
	if (bioskey(1)==0) return;
	rdkey=bioskey(0);
	switch (rdkey) {
		case RTARR:
				   do_value[doch]='0';
				   write_DO(boardI);
				   break;
		case LTARR:
				   do_value[doch]='1';
				   write_DO(boardI);
				   break;
		case UPARR:
				   if (--doch<0) doch=do_no-1;
				   break;
		case DNARR:
				   if (++doch>=do_no) doch=0;
				   break;
		case ESC  :
				   edit_f=OFF;
				   show_DO(KNULL);
				   showmenu(menuI);
				   showhelp(KNULL);
				   return;
		default :
				   break;
	  }
	  write_DO();
	  show_DO(doch);
  }